﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Course_Project.Modules;
namespace Course_Project.Forms
{
    public partial class OperatorPanel : Form
    {
        public OperatorPanel()
        {
            InitializeComponent();
            GenForms GenForms = new GenForms();

        }

        private void OperatorPanel_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "ticketsDataSet.ВыводНаправлений1". При необходимости она может быть перемещена или удалена.
            this.выводНаправлений1TableAdapter.Fill(this.ticketsDataSet.ВыводНаправлений1);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "ticketsDataSet.ВыводНаправлений1". При необходимости она может быть перемещена или удалена.
            this.выводНаправлений1TableAdapter.Fill(this.ticketsDataSet.ВыводНаправлений1);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "compDataSet.Companies". При необходимости она может быть перемещена или удалена.
            this.companiesTableAdapter.Fill(this.compDataSet.Companies);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "ticketsDataSet.ВыводНаправлений". При необходимости она может быть перемещена или удалена.
            
            // TODO: данная строка кода позволяет загрузить данные в таблицу "precDataSet.ВыводПрактик". При необходимости она может быть перемещена или удалена.
            this.выводПрактикTableAdapter.Fill(this.precDataSet.ВыводПрактик);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "proModulesDataSet.ВыовдПрофМодулей". При необходимости она может быть перемещена или удалена.
            this.выовдПрофМодулейTableAdapter.Fill(this.proModulesDataSet.ВыовдПрофМодулей);

            // TODO: данная строка кода позволяет загрузить данные в таблицу "studOperDataSet.СтудентыГруппы". При необходимости она может быть перемещена или удалена.
            this.студентыГруппыTableAdapter.Fill(this.studOperDataSet.СтудентыГруппы);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "groupsOperDataSet.Специальность_Группы". При необходимости она может быть перемещена или удалена.
            this.специальность_ГруппыTableAdapter.Fill(this.groupsOperDataSet.Специальность_Группы);
            // TODO: данная строка кода позволяет загрузить данные в таблицу "specOperDataSet1.СпециальностиВывод". При необходимости она может быть перемещена или удалена.
            this.специальностиВыводTableAdapter.Fill(this.specOperDataSet1.СпециальностиВывод);
            this.branchesTableAdapter.Fill(this.branchesOperDataSet.Branches);

            this.groupsTableAdapter.Fill(this.groupsOperDataSet.Groups);

            try
            {
                this.studentsTableAdapter.Fill(this.studOperDataSet.Students);
            }
            catch (System.Data.ConstraintException exception)
            {
                MessageBox.Show(exception.Source, "Ошибка!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);

            }
            MainMenu.DrawItem += new DrawItemEventHandler(tabControl1_DrawItem);
            SearchBox.Text = "Введите критерий поиска"; //подсказка
            SearchBox.ForeColor = Color.Gray;

            SearchSpecBox.Text = "Введите критерий поиска"; //подсказка
            SearchSpecBox.ForeColor = Color.Gray;
        }

        private void tabControl1_DrawItem(Object sender, System.Windows.Forms.DrawItemEventArgs e)
        {
            Graphics g = e.Graphics;
            Brush _textBrush;

            // Get the item from the collection.
            TabPage _tabPage = MainMenu.TabPages[e.Index];

            // Get the real bounds for the tab rectangle.
            Rectangle _tabBounds = MainMenu.GetTabRect(e.Index);

            if (e.State == DrawItemState.Selected)
            {

                // Draw a different background color, and don't paint a focus rectangle.
                _textBrush = new SolidBrush(Color.Black);
                g.FillRectangle(Brushes.LightGray, e.Bounds);
            }
            else
            {
                _textBrush = new System.Drawing.SolidBrush(e.ForeColor);
                e.DrawBackground();
            }

            // Use our own font.
            Font _tabFont = new Font("Microsoft Sans Serif", 10.0f);

            // Draw string. Center the text.
            StringFormat _stringFlags = new StringFormat();
            _stringFlags.Alignment = StringAlignment.Center;
            _stringFlags.LineAlignment = StringAlignment.Center;
            g.DrawString(_tabPage.Text, _tabFont, _textBrush, _tabBounds, new StringFormat(_stringFlags));
        }

        //
        // Вкладка Отделения
        //

        private void addNewBranchLink_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            GenForms.AddBranch();
        }

        private void delBranchLink_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
        
            using (var db = new Database())
            {
                if (dataGridBranches.CurrentCell.Value.ToString() == null)
                {
                    MessageBox.Show("Не выбрано отделение для удаления!", "Ошибка!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);

                }
                else
                {
                    db.Database.ExecuteSqlCommand($"DELETE FROM Branches WHERE Title='{dataGridBranches.CurrentCell.Value.ToString()}'");
                    this.branchesTableAdapter.Fill(this.branchesOperDataSet.Branches);
                }

            }
        }

        private void BranchSortButton_Click(object sender, EventArgs e)
        {
            DataGridViewColumn  ColBranch = null;
            switch (sortListBranch.SelectedIndex)
            {
                case 0:
                    ColBranch = dataGridViewTextBoxColumn1;
                    break;
                case 1:
                    ColBranch = dataGridViewTextBoxColumn2;
                    break;

            }
            if (radioSortBranchUp.Checked)
                dataGridBranches.Sort(ColBranch, ListSortDirection.Ascending);
            else
                dataGridBranches.Sort(ColBranch, ListSortDirection.Descending);

        }

        private void SearchBox_TextChanged(object sender, EventArgs e)
        {
            for (int i = 0; i < dataGridBranches.RowCount; i++)
            {
                dataGridBranches.Rows[i].Selected = false;
                for (int j = 0; j < dataGridBranches.ColumnCount; j++)
                    if (dataGridBranches.Rows[i].Cells[j].Value != null)
                        if (dataGridBranches.Rows[i].Cells[j].Value.ToString().Contains(SearchBox.Text))
                        {
                            dataGridBranches.Rows[i].Selected = true;
                            break;
                        }
            }
        }

      

        

        private void SearchBox_Enter(object sender, EventArgs e)
        {
            SearchBox.Text = null;
            SearchBox.ForeColor = Color.Black;
        }
private void updateBranchTable_Click(object sender, EventArgs e)
        {
            this.специальностиВыводTableAdapter.Fill(this.specOperDataSet1.СпециальностиВывод);
        }

        //
        // Вкладка Отделения
        //

        private void linkLabel3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            GenForms.AddSpec();
        }
        private void delSpecLink_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            using (var db = new Database())
            {
                if (DataGridSpec.CurrentCell.Value.ToString() == null)
                {
                    MessageBox.Show("Не выбрана специальность для удаления!", "Ошибка!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);

                }
                else
                {
                    db.Database.ExecuteSqlCommand($"DELETE FROM Specialities WHERE Title='{DataGridSpec.CurrentCell.Value.ToString()}'");
                    this.специальностиВыводTableAdapter.Fill(this.specOperDataSet1.СпециальностиВывод);
                }

            }
        }

        private void SpecSortButton_Click(object sender, EventArgs e)
        {
            DataGridViewColumn ColSpec  = null;
            switch (sortListSpec.SelectedIndex)
            {
                case 0:
                    ColSpec = dataGridViewTextBoxColumn1;
                    break;
                case 1:
                    ColSpec = dataGridViewTextBoxColumn2;
                    break;

            }
        

            if (radioSortSpecUp.Checked)
                DataGridSpec.Sort(ColSpec, ListSortDirection.Ascending);
            else
                DataGridSpec.Sort(ColSpec, ListSortDirection.Descending);

        }

        private void SearchSpecBox_TextChanged(object sender, EventArgs e)
        {
            for (int i = 0; i < DataGridSpec.RowCount; i++)
            {
                DataGridSpec.Rows[i].Selected = false;
                for (int j = 0; j < DataGridSpec.ColumnCount; j++)
                    if (DataGridSpec.Rows[i].Cells[j].Value != null)
                        if (DataGridSpec.Rows[i].Cells[j].Value.ToString().Contains(SearchSpecBox.Text))
                        {
                            DataGridSpec.Rows[i].Selected = true;
                            break;
                        }
            }
        }

        private void SearchSpecBox_Enter(object sender, EventArgs e)
        {
            SearchSpecBox.Text = null;
            SearchSpecBox.ForeColor = Color.Black;
        }

        private void updateSpecTable_Click(object sender, EventArgs e)
        {
            this.специальностиВыводTableAdapter.Fill(this.specOperDataSet1.СпециальностиВывод);
        }

        private void splitContainerBranch_Panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void appIco_Click(object sender, EventArgs e)
        {
            appIco.Visible = false;
            label7.Visible = true;
        }

        int clicks = 0;
        private void abobaPic_Click(object sender, EventArgs e)
        {
            //うんち
           
            clicks++;
            if (clicks == 10)
            {
                GenForms.EggForm();
                clicks = 0;
            }
        }

        private void MainMenu_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void radioSortBranchUp_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void radioSortBranchDown_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void sortListBranch_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void updateBranchTable_Click_1(object sender, EventArgs e)
        {

        }

        private void splitContainer5_Panel2_Paint(object sender, PaintEventArgs e)
        {

        }
    }

}