﻿using System.Linq;
using System.Security.Cryptography;
using System.Text;

namespace Course_Project.Modules
{
    class Cryptography
    {
        private static string GenerateHashString(HashAlgorithm algo, string text)
        {
            algo.ComputeHash(Encoding.UTF8.GetBytes(text));
            var result = algo.Hash;
            return string.Join(
            string.Empty,
            result.Select(x => x.ToString("x2")));
        }
        public static string GetSHA1(string text)
        {
            var result = default(string);
            using (var algo = new SHA1Managed())
            {
                result = GenerateHashString(algo, text);
            }
            return result;
        }
    }
}
